// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package machine

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// MachineClient is the client API for Machine service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type MachineClient interface {
	// StreamUpdates streams updates
	StreamUpdates(ctx context.Context, in *StreamUpdatesRequest, opts ...grpc.CallOption) (Machine_StreamUpdatesClient, error)
}

type machineClient struct {
	cc grpc.ClientConnInterface
}

func NewMachineClient(cc grpc.ClientConnInterface) MachineClient {
	return &machineClient{cc}
}

func (c *machineClient) StreamUpdates(ctx context.Context, in *StreamUpdatesRequest, opts ...grpc.CallOption) (Machine_StreamUpdatesClient, error) {
	stream, err := c.cc.NewStream(ctx, &Machine_ServiceDesc.Streams[0], "/vseth.vis.machine.Machine/StreamUpdates", opts...)
	if err != nil {
		return nil, err
	}
	x := &machineStreamUpdatesClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Machine_StreamUpdatesClient interface {
	Recv() (*Update, error)
	grpc.ClientStream
}

type machineStreamUpdatesClient struct {
	grpc.ClientStream
}

func (x *machineStreamUpdatesClient) Recv() (*Update, error) {
	m := new(Update)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// MachineServer is the server API for Machine service.
// All implementations must embed UnimplementedMachineServer
// for forward compatibility
type MachineServer interface {
	// StreamUpdates streams updates
	StreamUpdates(*StreamUpdatesRequest, Machine_StreamUpdatesServer) error
	mustEmbedUnimplementedMachineServer()
}

// UnimplementedMachineServer must be embedded to have forward compatible implementations.
type UnimplementedMachineServer struct {
}

func (UnimplementedMachineServer) StreamUpdates(*StreamUpdatesRequest, Machine_StreamUpdatesServer) error {
	return status.Errorf(codes.Unimplemented, "method StreamUpdates not implemented")
}
func (UnimplementedMachineServer) mustEmbedUnimplementedMachineServer() {}

// UnsafeMachineServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to MachineServer will
// result in compilation errors.
type UnsafeMachineServer interface {
	mustEmbedUnimplementedMachineServer()
}

func RegisterMachineServer(s grpc.ServiceRegistrar, srv MachineServer) {
	s.RegisterService(&Machine_ServiceDesc, srv)
}

func _Machine_StreamUpdates_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(StreamUpdatesRequest)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(MachineServer).StreamUpdates(m, &machineStreamUpdatesServer{stream})
}

type Machine_StreamUpdatesServer interface {
	Send(*Update) error
	grpc.ServerStream
}

type machineStreamUpdatesServer struct {
	grpc.ServerStream
}

func (x *machineStreamUpdatesServer) Send(m *Update) error {
	return x.ServerStream.SendMsg(m)
}

// Machine_ServiceDesc is the grpc.ServiceDesc for Machine service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Machine_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "vseth.vis.machine.Machine",
	HandlerType: (*MachineServer)(nil),
	Methods:     []grpc.MethodDesc{},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "StreamUpdates",
			Handler:       _Machine_StreamUpdates_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "vseth/vis/machine/machine.proto",
}
